import { IPage } from "../models/page.model";
import { IPageElementNode, PageNode } from "../models/page-node.model";
import { PageTextNode } from "./page-text-node";
import { PageElementNode } from "./page-element-node";
import { PageCustomNode } from "./page-custom-node";
import { PageNodeSchema } from "../models/element-schema.model";


export function nodeFactory(schema: PageNodeSchema, page: IPage, parentElement?: IPageElementNode): PageNode {
  const tag = schema.tag.split('_')[0];
  switch (tag) {
    case 'custom':
      return new PageCustomNode(schema, page, parentElement);
    case '#text':
      return new PageTextNode(schema, page, parentElement);
    default:
      return new PageElementNode(schema, page, parentElement);
  }
}